' 
'
'                             PB Main Template

    DECLARE FUNCTION partial(ByVal startat as DWORD,ByVal psrc as DWORD,ByVal ppatn as DWORD) as DWORD
    DECLARE FUNCTION StrLen(ByVal item as DWORD) as DWORD

' 

FUNCTION PBmain as LONG

    LOCAL spos  as DWORD
    LOCAL ptxt  as DWORD
    LOCAL ppatn as DWORD
    LOCAL txt   as ASCIIZ * 260
    LOCAL patn  as ASCIIZ * 32

    ptxt  = VarPtr(txt)
    ppatn = VarPtr(patn)

    txt = "Cannons to right of us, cannons to left of us, cannons in front of us vollied and thundered"

  ' text = "cannons to left"
    patn = "**nnons**o le**"

    spos = partial(spos,ptxt,ppatn)

    msgbox str$(spos)

End FUNCTION

' 

FUNCTION partial(ByVal startat as DWORD,ByVal psrc as DWORD,ByVal ppatn as DWORD) as DWORD

    #REGISTER NONE

 ' comment @ ------------------------------------------------------
 '         Partial string matching algorithm.
 '         Wildcard character is fixed at "*".
 '         Leading, mixed and trailing * allowed in search pattern.

 '         Arguments
 '         =========
 '         1.  startat :   zero based offset from start address
 '         2.  psrc    :   address of zero terminated source to search
 '         3.  ppatn   :   address of zero terminated pattern to search

 '         Return values
 '         =============
 '         -1 NO match
 '         0 and greater = zero based offset of match
 '         ------------------------------------------------------ @

    LOCAL lead   as DWORD          ' number of filler chars at start
    LOCAL lsrc   as DWORD          ' source length in bytes
    LOCAL lptn   as DWORD          ' pattern length in bytes
    LOCAL mptn   as DWORD          ' matching pattern length
    LOCAL bye    as DWORD          ' exit offset for main loop

    ! mov eax, startat             ' add starting offset to source address
    ! add psrc, eax

    StrLen ppatn
    ! mov lptn, eax                ' raw patn length
    StrLen psrc
    ! mov lsrc, eax                ' source length

    ! mov esi, psrc
    ! mov edi, ppatn
    ! sub edi, 1

  ' ----------------------------------------
  ' scan beginning of string for lead length
  ' ----------------------------------------
    ! mov lead, 0
    ! jmp lbl1
  lbl0:
    ! add lead, 1                 ' count the lead filler chars
  lbl1:
    ! add edi, 1                  ' increment EDI up to 1st non blank char
    ! cmp BYTE PTR [edi], "*"
    ! je lbl0
  ' ----------------------------------------

    ! mov eax, lptn
    ! sub eax, lead               ' sub lead from patn length
    ! mov mptn, eax               ' calc the len of the pattern to match
    ! sub mptn, 1

    ! mov bl, [edi]               ' 1st non filler char in BL
    ! add esi, lead               ' start counting the correct number
    ! sub esi, 1                  ' of characters in from start

  ' -----------------------
  ' calculate "bye" offset
  ' -----------------------
    ! mov eax, lsrc
    ! sub eax, lptn
    ! add eax, lead
    ! add eax, esi
    ! mov bye, eax
  ' -----------------------

  ' ****************************************************************

  mainloop:
    ! add esi, 1
    ! cmp [esi], bl               ' scan source for 1st non filler char
    ! je lbl2
    ! cmp esi, bye               ' test against exit offset
    ! jle mainloop
    ! jmp nomatch

  lbl2:
    ! mov edx, -1                 ' set index to -1
  matchloop:
    ! add edx, 1                  ' increment the index
    ! cmp edx, mptn               ' check against pattern length
    ! jg matched
    ! movzx ecx, BYTE PTR [edi+edx]           ' load current byte in pattern
    ! cmp cl, 42                  ' test if its a filler "*"
    ! je matchloop
    ! cmp cl, [esi+edx]           ' else test if it matches
    ! je matchloop                ' at next character
    ! jmp mainloop

  ' ****************************************************************

  matched:
    ! sub esi, psrc
    ! sub esi, lead
    ! mov eax, esi
    ! add eax, startat
    ! jmp outa_here

  nomatch:
    ! mov eax, -1

  outa_here:
    ! mov FUNCTION, eax

END FUNCTION

' 

FUNCTION StrLen(ByVal item as DWORD) as DWORD

    #REGISTER NONE

    ! mov     eax, item               ' get pointer to string
    ! lea     edx, [eax+3]            ' pointer+3 used in the end
    ! mov     ebx, &H80808080

  lbl0:
  ' --------------------
  ' manually unroll by 4
  ' --------------------
    ! mov     edi, [eax]              ' read first 4 bytes
    ! add     eax, 4                  ' increment pointer
    ! lea     ecx, [edi-&H01010101]   ' subtract 1 from each byte
    ! not     edi                     ' invert all bytes
    ! and     ecx, edi                ' and these two
    ! and     ecx, ebx
    ! jnz     nxt

    ! mov     edi, [eax]              ' read first 4 bytes
    ! add     eax, 4                  ' increment pointer
    ! lea     ecx, [edi-&H01010101]   ' subtract 1 from each byte
    ! not     edi                     ' invert all bytes
    ! and     ecx, edi                ' and these two
    ! and     ecx, ebx
    ! jnz     nxt

    ! mov     edi, [eax]              ' read first 4 bytes
    ! add     eax, 4                  ' increment pointer
    ! lea     ecx, [edi-&H01010101]   ' subtract 1 from each byte
    ! not     edi                     ' invert all bytes
    ! and     ecx, edi                ' and these two
    ! and     ecx, ebx
    ! jnz     nxt

    ! mov     edi, [eax]              ' read first 4 bytes
    ! add     eax, 4                  ' 4 increment DWORD pointer
    ! lea     ecx, [edi-&H01010101]   ' subtract 1 from each byte
    ! not     edi                     ' invert all bytes
    ! and     ecx, edi                ' and these two
    ! and     ecx, ebx
    ! jz      lbl0                    ' no zero bytes, continue loop

  nxt:
    ! test    ecx, &H00008080         ' test first two bytes
    ! jnz     lbl1
    ! shr     ecx, 16                 ' not in the first 2 bytes
    ! add     eax, 2
  lbl1:
    ! shl     cl, 1                   ' use carry flag to avoid branch
    ! sbb     eax, edx                ' compute length

    ! mov FUNCTION, eax

END FUNCTION

' 
